<?php
namespace Teknisa\CRM\Controller;

use Zeedhi\Framework\DTO;

class WizardProspectController {
    
    protected $wizardService;
    
    public function __construct ($wizardService){
        $this->wizardService = $wizardService;
    }
    
    public function executeQuery(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            
            $parameters = array(
                'QUERY'   => $row['query'] 
            );
            $mode = $row['type'];
            
            $resultQuery = $this->wizardService->executeQuery($parameters, $mode);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('resultQuery', $resultQuery));
            
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}
?>