function crm30000000_Compromisso_Controller(ScreenService, templateManager, CRM_Utilities, General, restEngine, ZHPromise, Messages, API_GoogleCalendar, evolutionTabController, metaDataFactory) {
    
    var self = this;
    
    var backUpactions;
    var actionReturnCalendar;
    var filterChanged = false;
    var syncronized = false;
    
    CRM_Utilities.addController(this, 'crm30000000_Compromisso_Controller');
    
    /**
     * Função para designar o procedimento
     * a ser feito (INSERT/UPDATE).
     * 
     * @param {object} widget widget ativa
     * onde está sendo realizado o cadastro.
    */
    this.saveCommitment = function(widget) {
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
    
        currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
    
        if (currentRow.__is_new) {
            General.callRestEngine("product#/verifyGroupRel", "DataSet", [currentRow]).then(function(response) {
                if (response.dataset && response.dataset.error) {
                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                }
                if (response.dataset && response.dataset.GROUPREL[0] == false) {
                    if (widget.isValid) {
                        this.defineGoogleCalendarStatus(widget);
                        this.saveNewCommitment(widget).then(function() {
                            if (widget.parent.parent.name == 'LIST_COMPROMISSO') {
                                widget.parent.parent.reload();
                            } else {
                                widget.reload();
                            }
                        });
                    }
                } else {
                    ScreenService.showMessage('Operação Bloqueada! O parceiro de negócio está relacionado ao parceiro:<br>' + response.dataset.GROUPREL[0]['NRINSCRICAOPARC'] + ' - ' + response.dataset.GROUPREL[0]['NMPRINCIPALPARC'] + '!');
                }
            }.bind(this));
        } else {
            if (widget.isValid) {
                this.defineGoogleCalendarStatus(widget);
                this.saveNewCommitment(widget).then(function() {
                    if (widget.parent.parent.name == 'LIST_COMPROMISSO') {
                        widget.parent.parent.reload();
                    } else {
                        widget.reload();
                    }
                });
            }
        }
    };
    
    this.setSelectedFirstDayOnStripe = function() {
        var wid = templateManager.container.getWidget('CALENDARIO');
        var stripe = templateManager.container.getWidget('stripe');
        var stripeDateField = CRM_Utilities.getObjectPositionInArrayByName(stripe.fields, "SELECTEDAY");
        stripe.fields[stripeDateField].label = "Dia Selecionado:";
        
        wid.getEventsWidget().dataSource.data = [];
    };
    
    /**
     * Define se a api do Google trabalhará com um
     * evento já existente ou criará um novo.
     * 
     * @param {object} widget widget base para inserir
     * um compromisso.
    */
    this.defineGoogleCalendarStatus = function(widget) {
        
        var currentRow = widget.currentRow;
        currentRow.DEFINEEVENTOGOOGLE = currentRow.__is_new ? true : false;
    };
    
    /**
     * Função para salvar(marcar) um novo
     * compromisso.
     * 
     * @param {object} widget widget ativar
     * onde está sendo realizado o cadastro
     * do compromisso.
    */
    this.saveNewCommitment = function(widget) {
        
        if(!widget.isValid()) {
            return;
        }
        
        var currentRow = widget.currentRow;
        var calendarWidget = templateManager.container.getWidget('CALENDARIO');
        
        this.setCommitmentDateInCurrentRow(widget);
        this.configureCommitmentIconUrl(widget);
        this.changeParticipantsWidgetActivation(true);
        this.changeDateFieldsTemplateToTextView(widget);
        this.returnDefaultActionsContainer();
        this.changeActionLabel(widget);
        
        return General.widgetSave(widget).then(function(response) {
            if(response.dataset && response.dataset.error) {
                ScreenService.showMessage(response.dataset.error, 'ERROR');
                ScreenService.alertNotification('Nenhum participante adicionado foi notificado por falta dos dados na parametrização.', 5000);
            }
            calendarWidget.reloadSchedulerWidget();
            
            widget.view();
            
            if(currentRow.DEFINEEVENTOGOOGLE && Boolean(templateManager.SYNCGOOGLECALENDAR)) {
                this.addEventToLoggedUserGoogleCalendar(currentRow);
            }else if(Boolean(templateManager.SYNCGOOGLECALENDAR)) {
                this.editGoogleEvent(currentRow);
            }
            
            currentRow.NRSEQPLANOCUPA = response.dataset.columnsToReturn.NRSEQPLANOCUPA;
            
        }.bind(this));
            
    };
    
    /**
     * Função para remover a máscara do dia
     * e do horário do compromisso.
     * 
     * @param {object} widget widget ativa
     * onde foi registrado a data e o horário
     * do compromisso.
    */
    this.setCommitmentDateInCurrentRow = function(widget) {
        var currentRow = widget.currentRow;
        
        currentRow.DTINIPLANOCUPA = currentRow.DTINI.replace(/\sàs\s/, " ");
        currentRow.DTFINPLANOCUPA = currentRow.DTFIM.replace(/\sàs\s/, " ");

    };
    
    this.changeWidgetTemplateToFormView = function(widget) {
        
        widget.template = "widget/form-view.html";
            
    };
    
    this.changeDateFieldsTemplateToTextView = function() {
        
        var widget = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        
        var startDateField = widget.getField("DTINI");
        var endDateField = widget.getField("DTFIM");
        
        startDateField.template = "field/text-edit.html";
        endDateField.template = "field/text-edit.html";
        
        startDateField.reload();
        endDateField.reload();
        
    };
    
    this.changeDateFieldsTemplateToDateTime = function() {
        
        var widget = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        
        var startDateField = widget.getField("DTINI");
        var endDateField = widget.getField("DTFIM");
        
        startDateField.template = "field/datetime.html";
        endDateField.template = "field/datetime.html";
        
        startDateField.reload();
        endDateField.reload();
        
    };
    
    this.configureCommitmentIconUrl = function(widget) {
        
        var currentRow = widget.currentRow;
        
        if(currentRow.DSCAMINHOICONE) {
            currentRow.DSCAMINHOICONE = window.fileServerBaseUrl + currentRow.DSCAMINHOICONE;       
        }
            
    };
    
    this.setEndCommitment = function(widget) {
        var currentRow = widget.currentRow;
        var commitmentInitDate = currentRow.DTINI;
        
        if(commitmentInitDate && !currentRow.DTFIM) {
            var DTINI30minutesLater = moment(commitmentInitDate, 'DD/MM/YYYY HH:mm').add(30, 'minutes').format('DD/MM/YYYY HH:mm');
            
            currentRow.DTFIM = DTINI30minutesLater.replace(/\s/, " às ");
        }
        
        templateManager.updateTemplate();
    };
    
    this.setEndCommitmentFormated = function(widget) {
        var currentRow = widget.currentRow;
        var commitmentInitDate = currentRow.DTINI;
        
        if(commitmentInitDate && !currentRow.DTFIM) {
            var DTINI30minutesLater = moment(commitmentInitDate, 'DD/MM/YYYY HH:mm').add(30, 'minutes').format('DD/MM/YYYY HH:mm');
            currentRow.DTFIM = DTINI30minutesLater;
            widget.getField('DTFIM').reload();
        }
        
        templateManager.updateTemplate();
    };
    
    this.dateValidation = function(verifiedField) {
        var widget = templateManager.container.getActiveWidget();
        
        var currentRow = widget.currentRow;
        
        var objectInitialDate = moment(currentRow.DTINI, 'DD/MM/YYYY HH:mm');
        var objectFinalDate = moment(currentRow.DTFIM, 'DD/MM/YYYY HH:mm');
        
        if(objectFinalDate.diff(objectInitialDate) < 0 && currentRow.DTINI && verifiedField.name === 'DTFIM') {
            currentRow.DTFIM = "";
            ScreenService.showMessage('Selecione uma data final válida.');
        }
        else if(objectInitialDate.diff(objectFinalDate) > 0 && currentRow.DTFIM && verifiedField.name === 'DTINI') {
            currentRow.DTINI = "";
            ScreenService.showMessage('Selecione uma data inicial válida.');
        }
    };
    
    this.insertFilterNMMOTIEVOCON = function(widget) {
        
            var fieldMotiEvoCon = widget.getField('NMMOTIEVOCON');
            var filterMotiEvoCon = fieldMotiEvoCon.dataSourceFilter;
            var infosOperatorLogged = CRM_Utilities.getLoggedOperatorInfos();
            
            fieldMotiEvoCon.dataSourceFilter[self.getFilterPosition(filterMotiEvoCon, 'P_CDOPERADOR')].value = infosOperatorLogged.CDOPERADOR;
            fieldMotiEvoCon.dataSourceFilter[self.getFilterPosition(filterMotiEvoCon, 'P_NRORG')].value = infosOperatorLogged.NRORG;
            
            fieldMotiEvoCon.reload();
    };
    
    this.getFilterPosition = function(dataSourceFilter,name) {
        var indexFilterObject;
        
        dataSourceFilter.forEach(function(value,i) {
            if(value.name === name) {
                indexFilterObject = i;
                return;
            }    
        });
        return indexFilterObject;
    };
    
    this.newCommitmentAndFormatsWidget = function(widget) {
        
        var widgetNewCommitment = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        var commitmentTabs = templateManager.container.getWidget("container_tabbed");
        
        widgetNewCommitment.parent.parent = widget;
        this.changeDateFieldsTemplateToDateTime();
        
        ScreenService.openSwipe(commitmentTabs).then(function() {
            
            this.changeParticipantsWidgetActivation(false);
            
            widgetNewCommitment.newRow();
            widgetNewCommitment.edit();
            widgetNewCommitment.template = 'widget/form.html';
            widgetNewCommitment.activate();
            
            this.setCommitmentDefaultValues(widgetNewCommitment);
            
        }.bind(this), function(error) {
            ScreenService.closeSwipe();
            ScreenService.showMessage(error);
        });
    };
    
    this.changeParticipantsWidgetActivation = function(isEnabled) {
        
        var participantsWidget = templateManager.container.getWidget("WDGT_COMMITMENT_PARTICIPANTS");
        
        participantsWidget.enabled = isEnabled;
        
    };
    
    /**
     * Função para setar os valores iniciais
     * de um cadastro de compromisso.
     * 
     * @param {object} widget widget ativa que
     * terá os valores recebidos em sua currentRow.
     * 
    */
    this.setCommitmentDefaultValues = function(widget) {
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.CDFILIAL = "";
        currentRow.NRCONTATO = "";
        currentRow.DSCORCARD = "";
        currentRow.DSPLANOCUPA = "";
        currentRow.CDMOTIEVOCON = "";
        currentRow.NRSEQCONTATO = "";
        currentRow.NRPARCNEGOCIO = "";
        currentRow.DSCAMINHOICONE = "";
        currentRow.HRINIPLANOCUPA = "";
        currentRow.HRFINPLANOCUPA = "";
        currentRow.NRRELACIONAPARC = "";
        currentRow.CDINTEPLANOCUPA = "";
        currentRow.NRTIPOCOMPROMISSO = "";
        currentRow.NRCLASSIFICACOMPR = "";
        currentRow.TIPO = "";
        currentRow.NRSEQOPORT = "";
        widget.currentRow.IDSTATPLANOCUPA = "P";
        
        currentRow.NMOPERADORESPONS = loggedOperatorInfos.NMOPERADOR;
        currentRow.CDOPERADORESPONS = loggedOperatorInfos.CDOPERADOR;
        currentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        currentRow.NRPARCNEGOCIO = loggedOperatorInfos.NRPARCNEGOCIO;
        currentRow.NRORG = loggedOperatorInfos.NRORG;
            
    };
    
    this.setDefaultCommitmentState = function(widget) {
        
        widget.currentRow.IDSTATPLANOCUPA = "P";
            
    };
    
    this.setCDOPERADORInCurrentRow = function() {
        var widget = templateManager.container.getActiveWidget();
        
        widget.currentRow.CDOPERADOR = widget.currentRow.CDOPERADORESPONS;
    };
    
    this.closeSwipeNewCommitment = function(widget) {
        this.changeDateFieldsTemplateToTextView();
        
        if (widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
			if (indexOfCurrentRow !== -1) {
				widget.dataSource.data.pop();
			}
			
			ScreenService.closeSwipe();
        }else{
            for (var i in widget.backupRow) {
				widget.currentRow[i] = widget.backupRow[i];
			}
			
			widget.view();
        }
    };
    
    this.deleteCommitmentAndParts = function(widget) {
        var currentRow = widget.currentRow;
        
        if(!Boolean(currentRow.NOEDITABLE)) {
            
            ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question',
            function (success) {
                var calendarWidget = templateManager.container.getWidget('CALENDARIO');
                var parentWidget = widget.parent.parent; //Não trocar por getParent()
                var parametroRestEngine = {
                    'requestType':'Row',
                    'row': widget.currentRow
                };
                
                restEngine.post('/deleteCommitmentParts', parametroRestEngine,
                    
                    function(success) {
                        
                    },undefined,
                    function(error) {
                        
                    }
                );
                
                restEngine.post('/deleteCommitment', parametroRestEngine,
                    
                    function(success) {
                        
                        if(templateManager.SYNCGOOGLECALENDAR) {
                            API_GoogleCalendar.deleteGoogleEvent(currentRow.NRSEQPLANOCUPA);    
                        }
                        this.showActionReturnCalendar();
                        
                        ScreenService.closeSwipe().then(function() {
                            
                            ScreenService.closeSwipe();
                            parentWidget.reload();
                            calendarWidget.reloadSchedulerWidget();
                            if(parentWidget.name == "LIST_COMPROMISSO") {
                                parentWidget.activate();
                            }else {
                                calendarWidget.activate();
                            }
                            
                        });
                        
                    }.bind(this),undefined,
                    function(error) {
                        
                    }
                );
            }.bind(this),
            function(error) {
                
            });
            
        }else{
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(currentRow.BECAUSENOEDITABLE));
        }
    };
    
    this.formatDateField = function(field) {
        var valueField = field.value();
        
        if(valueField !== "") {
            
            field.value(valueField.replace(/\s/, " às "));
        }
    };
     
    this.setVisibleFieldReferenceCode = function() {
        var widget = templateManager.container.getActiveWidget();
        var currentRow = widget.currentRow;
        var fieldCaso = widget.getField('FIELDCASO');
        var fieldOport = widget.getField('FIELDOPORTUNI');
        
        if(currentRow.TIPO === "OPORTUNIDADE") {
            fieldCaso.isVisible = false;
            fieldCaso.showOnForm = false;
            fieldCaso.value("");
            fieldOport.isVisible = true;
            fieldOport.showOnForm = true;
            fieldCaso.validations = {};
            fieldOport.validations = {required:true};
            fieldOport.label = "Oportunidade de Negócio";
            fieldOport.readOnly = false;
            fieldCaso.validations = {};
        }else if (currentRow.TIPO === "PARCEIRO") {
            fieldOport.isVisible = false;
            fieldOport.showOnForm = false;
            fieldOport.value("");
            fieldCaso.isVisible = true;
            fieldCaso.showOnForm = true;
            fieldOport.validations = {};
            fieldCaso.validations = {required:true};
            fieldCaso.label = "Parceiro de Negócio";
            fieldCaso.readOnly = false;
            fieldOport.validations = {};
        }else{
            fieldCaso.validations = {};
            fieldOport.validations = {};
            fieldOport.label = "";
            fieldCaso.label = "";
            fieldOport.readOnly = true;
            fieldCaso.readOnly = true;
        }
        templateManager.updateTemplate();
    };
    
    this.setFilterParcNegocioAndCleanField = function(widget) {
        var currentRow = widget.currentRow;
        var filterCaso;
        var filterOport;
        var fieldCaso = widget.getField('FIELDCASO');
        var fieldOport = widget.getField('FIELDOPORTUNI');
        var fieldTipo = widget.getField('TIPO');
        
        if (!Util.isUndefinedOrNull(currentRow.NMPRINCIPALPARC) && currentRow.NMPRINCIPALPARC !== '') {
            filterCaso = [ 
                {
                    "name": "NRPARCNEGOCIO",
                    "operator": "=",
                    "value": widget.currentRow.NRPARCNEGOCIO
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": widget.currentRow.NRORG
                }
            ];
            filterOport = [ 
                {
                    "name": "NRPARCOPORT",
                    "operator": "=",
                    "value": widget.currentRow.NRPARCNEGOCIO
                },
                { 
                    "name": "P_NRORG", 
                    "operator": "=", 
                    "value": widget.currentRow.NRORG
                    
                },
                {
                    "name": "IDTPOPERADOR", 
                    "operator": "=", 
                    "value": "E"
                },
                {
                    "name": "SITUACAO", 
                    "operator": "=",
                    "value": "A"
                },
                {
                    "name": "CRM_NRORGTRAB",
                    "operator": "=",
                    "value": getLocalVar('CRM_NRORGTRABALHO')
                }
            ];
            
            fieldCaso.readOnly = true;
            fieldOport.readOnly = true;
            fieldTipo.readOnly = false;
            
        }else{
            filterCaso = [];
            filterOport = [];
            fieldTipo.value("");
            fieldCaso.readOnly = true;
            fieldOport.readOnly = true;
            fieldTipo.readOnly = true;
        }
        
        fieldCaso.dataSourceFilter = filterCaso;
        fieldCaso.value("");
        fieldCaso.validations = {};
        fieldCaso.reload();
        fieldOport.dataSourceFilter = filterOport;
        fieldOport.value("");
        widget.currentRow.TIPO = "";
        fieldOport.validations = {};
        fieldOport.reload();
        
        templateManager.updateTemplate();
    };
    
    this.openSwipeFromCalendar = function(calendarWidget) {
        var widgetNewCommitment = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        
        widgetNewCommitment.parent.parent = calendarWidget;
        this.openAndEditSwipeCardView(calendarWidget);
    };
    
    this.openSwipeFromList = function(listWidget) {
        var widgetNewCommitment = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        
        widgetNewCommitment.parent.parent = listWidget;
        this.openAndEditSwipeCardView(listWidget);
    };
    
    this.openAndEditSwipeCardView = function(widget) {
        var currentRow = widget.currentRow;
        
        var widgetCardView = templateManager.container.getWidget('container_tabbed');
        var widgetCalendar = templateManager.container.getWidget('CALENDARIO');
        var widgetNewCommitment = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        var widgetParticipantes = templateManager.container.getWidget('WDGT_COMMITMENT_PARTICIPANTS');
        
        widget.getParent().widgetToBack = widget.name;
        var cardCurrentRow = angular.copy(currentRow);
        
        this.getActionReturnCalendar();
        this.returnDefaultActionsContainer();
        
        ScreenService.openSwipe(widgetCardView).then(function() {

            widgetCardView.currentWidget = widgetNewCommitment;
            widgetNewCommitment.view();
            widgetNewCommitment.template = 'widget/form-view.html';
            widgetNewCommitment.activate();

            widgetNewCommitment.currentRow = cardCurrentRow;
            
            var cardViewCurrentRow =  widgetNewCommitment.currentRow;
            
            cardViewCurrentRow.DTINI = cardViewCurrentRow.DTINIPLANOCUPA.replace(/\s/, " às ").substring(0,19);
            cardViewCurrentRow.DTFIM = cardViewCurrentRow.DTFINPLANOCUPA.replace(/\s/, " às ").substring(0,19);
            cardViewCurrentRow.NMOPERADORESPONS = cardViewCurrentRow.NMOPERADOR;
            
            cardViewCurrentRow.CARDVISUALIZATIONMODE = true;
            
            if(cardViewCurrentRow.TIPO === "OPORTUNIDADE") {
                widgetNewCommitment.getField('FIELDOPORTUNI').isVisible = true;
                widgetNewCommitment.getField('FIELDOPORTUNI').label = "Oportunidade";
                widgetNewCommitment.getField('FIELDCASO').isVisible = false;
                widgetNewCommitment.getField('FIELDCASO').label = "";
                cardViewCurrentRow.FIELDOPORTUNI = cardViewCurrentRow.DSREF;
            }
            else if(cardViewCurrentRow.TIPO === "PARCEIRO" || cardViewCurrentRow.TIPO === "CASO") {
                widgetNewCommitment.getField('FIELDCASO').isVisible = true;
                widgetNewCommitment.getField('FIELDCASO').label = "Parceiro";
                widgetNewCommitment.getField('FIELDOPORTUNI').isVisible = false;
                widgetNewCommitment.getField('FIELDOPORTUNI').isVisible = "";
                cardViewCurrentRow.FIELDCASO = cardViewCurrentRow.DSREF;    
            }
            
            this.changeActionLabel(widgetNewCommitment);
            
        }.bind(this));
        
        widgetCardView.reload();
        
    };
    
    this.closeSwipeCardView = function(widget) {
        if(widget.currentRow.CARDVISUALIZATIONMODE || widget.name === "WDGT_COMMITMENT_PARTICIPANTS") {
            this.showActionReturnCalendar();
        }else{
            this.returnDefaultActionsContainer();
        }
        
        ScreenService.closeSwipe();
        
        if(widget.parent.parent.name == "LIST_COMPROMISSO") {
            var list = templateManager.container.getWidget('LIST_COMPROMISSO');
            list.activate();
        }else {
            var calendario = templateManager.container.getWidget('CALENDARIO');
            calendario.activate();
        }
    };
    
    this.updateStatusPlanocupa = function(newStatus) {
        var widget = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        var widgetCalendar = templateManager.container.getWidget("CALENDARIO");
        var currentRow = widget.currentRow;
        
        var backupIDSTATPLANOCUPA = currentRow.IDSTATPLANOCUPA;
        currentRow.IDSTATPLANOCUPA = newStatus;
        
        var parametroRestEngine = {
            'requestType':'Row',
            'row': currentRow
        };
        
        if(!Boolean(widget.currentRow.NOEDITABLE)) {
            restEngine.post('/updateStatusPlanocupa', parametroRestEngine,
                    
                        function(success) {
                            ScreenService.showMessage("Status atualizado com sucesso.");
                            ScreenService.closePopup();
                            widgetCalendar.reloadSchedulerWidget();
                        },undefined,
                        function(error) {
                            ScreenService.showMessage("Erro ao atualizar o status do compromisso.");
                            currentRow.IDSTATPLANOCUPA = backupIDSTATPLANOCUPA;
                            ScreenService.closePopup();
                        }
                    );
            widget.reload();
        }else{
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(widget.currentRow.BECAUSENOEDITABLE));
        }
        
    };

    this.prepareEditCommitmentEdit = function(newCommitCurrentRow, cardViewCurrentRow) {
        
        newCommitCurrentRow.__is_new = false;
        newCommitCurrentRow.DTINI = cardViewCurrentRow.DTINI;
        newCommitCurrentRow.DTFIM = cardViewCurrentRow.DTFIM;
        newCommitCurrentRow.CDOPERADORESPONS = cardViewCurrentRow.CDOPERADOR;
        newCommitCurrentRow.NMOPERADORESPONS = cardViewCurrentRow.NMOPERADOR;
        
        if(cardViewCurrentRow.TIPO === "OPORTUNIDADE") {
            newCommitCurrentRow.FIELDOPORTUNI = cardViewCurrentRow.DSREF;
        }
        else if(cardViewCurrentRow.TIPO === "PARCEIRO" || cardViewCurrentRow.TIPO === "CASO") {
            newCommitCurrentRow.FIELDCASO = cardViewCurrentRow.DSREF;    
        }
        
        newCommitCurrentRow.CDOPERADORPART = cardViewCurrentRow.CDOPERADORPART;
        
        
    };
    
    this.editCommitment = function(widget) {
        
        var currentRow = widget.currentRow;
        
        if(Boolean(currentRow.NOEDITABLE)) {
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(currentRow.BECAUSENOEDITABLE));
        }else {
            
            this.changeDateFieldsTemplateToDateTime();
            this.changeParticipantsWidgetActivation(false);
            General.widgetEdit(widget);
            widget.template = 'widget/form.html';
            widget.activate();
        }
        
    };
    
    this.setFilterPartipantes = function(args) {
        var widgetParticipantes = templateManager.container.getWidget("WDGT_COMMITMENT_PARTICIPANTS");
        var widgetCompromisso   = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        widgetParticipantes.currentRow.NRPARCNEGOCIOCOMP = widgetCompromisso.NRPARCNEGOCIO;
        widgetParticipantes.dataSourceFilter.forEach(function(filter) {
            if(filter.name === "NRSEQPLANOCUPA") {
                filter.value = widgetCompromisso.currentRow.NRSEQPLANOCUPA;
            } 
        });
    };
    
    this.getContainerDefaultActions = function() {
        backUpactions = templateManager.container.actions;
    };
    
    this.getActionReturnCalendar = function() {
        
        actionReturnCalendar = templateManager.container.actions;
        
    };
    
    this.showActionReturnCalendar = function() {
        templateManager.container.actions = actionReturnCalendar;    
    };
    
    this.returnDefaultActionsContainer = function() {
        templateManager.container.actions = backUpactions;    
    };
    
	this.setDefaultFilter = function(widget) {
        
        this.changeFilterOperator(widget);
        
	};
	
	this.getDateSixMonthAgo = function() {
	    var currentDate = CRM_Utilities.getCurrentDate();
        var dateSixMonthAgo = CRM_Utilities.subtractDateByMonth(currentDate,6);
        return moment(dateSixMonthAgo, 'DD/MM/YYYY').format('01/MM/YYYY');
	};
	
	this.changeFilterOperator = function(widget) {
	    
	    var cdoperador = widget.__filterPopup.currentRow.CDOPERADOR;
	    var change = false;
	    
	    if(!Util.isEmptyOrBlank(cdoperador) && (typeof cdoperador === "object")) {
	        change = true;
	    }
	    
	    var filters = [];
	    widget.dataSourceFilter.forEach(function(filter) {
	        if(filter.name !== "CDOPERADOR" && change === true) {
	            filters.push(filter);
	        }
	    });
	    
	    if(change) {
            widget.dataSourceFilter = filters;	    
	    }else{
	        
	        var operatorFilter = templateManager.LOGGEDOPERATOR.CDOPERADOR;
	        
	        if(Util.isEmptyOrBlank(cdoperador)) {
	            widget.dataSourceFilter.push({name:"CDOPERADOR", operator: "IN", value: operatorFilter});
	        }
	        
	    }
    };
    
    this.setListaFilter = function(widget) {
        this.fixHourFilter(widget);
        var listaWidget = templateManager.container.getWidget('LIST_COMPROMISSO');
        listaWidget.dataSourceFilter = widget.dataSourceFilter;
        filterChanged = true;
    }
    
    this.fixHourFilter = function(widget) {
        widget.dataSourceFilter.forEach(function(filter) {
            if(filter.name === "DTINIPLANOCUPA" && filter.operator === "BETWEEN")
                filter.value[1] += ' 23:59';
        });  
    };
    
    /**
     * Procedimento para setar o dia selecionado
     * no stripe(widget).
    */
    this.setSelectedDayOnStripe = function() {
        var stripe = templateManager.container.getWidget('stripe');
        var stripeDateField = CRM_Utilities.getObjectPositionInArrayByName(stripe.fields, "SELECTEDAY");
        var calendarWidget = templateManager.container.getWidget('CALENDARIO');
        
        stripe.fields[stripeDateField].label = "Dia Selecionado: " + calendarWidget.getCalendarWidget().currentRow;
    
    };
    
    /**
     * Procedimento para verificar se existe
     * compromissos com mais de um dia.
    */
    this.checkCommitmentsWithInterval = function() {
            var calendar = templateManager.container.getWidget('CALENDARIO');
            var calendarData = calendar.dataSource.data;
            
            calendarData.map(function(row) {
                
                if(row.DATAINI !== row.DATAFIN) {
                    var copyCommitment = angular.copy(row);
                    this.fillCommitmentIntervalDays(calendar,copyCommitment);
                }
                    
            }.bind(this));
        
    };
    
    /**
     * Procedimento para preencher os dias
     * do intervalo de um compromisso.
     * 
     * @param {object} calendar  widget principal da
     * tela de compromisso com os compromisso retornados.
     * 
     * @param {object} commitment compromisso á ser preenchido.
    */
    this.fillCommitmentIntervalDays = function(calendar, commitment) {
        var commitmentInitDate = commitment.DATAINI;
        var commitmentEndDate = commitment.DATAFIN;
        var intervalInitDate = CRM_Utilities.addDaysToDate(commitmentInitDate, 1, 'DD/MM/YYYY');
        var commitmentEndDateMoreOne = CRM_Utilities.addDaysToDate(commitmentEndDate, 1, 'DD/MM/YYYY');
        var daysCont = intervalInitDate;
        
        while(daysCont != commitmentEndDateMoreOne) {
            calendar.dataSource.data.push(this.createCommitmentIntervalDay(commitment, daysCont));
            daysCont = CRM_Utilities.addDaysToDate(daysCont, 1, 'DD/MM/YYYY');
        }
    
    };
    
    /**
     * Procedimento para retornar uma row de compromisso
     * de acordo com o intervaldo que está sendo criado.
     * 
     * @param {object} commitment compromisso referência.
     * 
     * @param {number} currentIntervalDay Dia referente
     * ao intervalo que está sendo criado.
    */
    this.createCommitmentIntervalDay = function(commitment, currentIntervalDay) {
        var newCommitmentIntervalDay = angular.copy(commitment);
        var commitmentescription = commitment.DSPLANOCUPA ? commitment.DSPLANOCUPA : "";
        
        newCommitmentIntervalDay.DEFAULTDATAINI = commitment.DATAINI;
        newCommitmentIntervalDay.DATAINI = currentIntervalDay;
        newCommitmentIntervalDay.DATAFIN = currentIntervalDay;
        /*newCommitmentIntervalDay.DTINIPLANOCUPA = currentIntervalDay + ' ' + commitment.HORAINI;
        newCommitmentIntervalDay.DTFINPLANOCUPA = currentIntervalDay + ' ' + commitment.HORAFIN;*/
        newCommitmentIntervalDay.DSPLANOCUPA = '[REFERENTE AO COMPROMISSO DO DIA: ' + commitment.DATAINI + '] ' + commitmentescription;
        newCommitmentIntervalDay.REFERENCIA = '[REFERENTE AO COMPROMISSO DO DIA: ' + commitment.DATAINI + ']';
        newCommitmentIntervalDay.NOEDITABLE = true;
        newCommitmentIntervalDay.BECAUSENOEDITABLE = "Realize a operação no dia raiz(" + commitment.DATAINI + ')';
        
        return newCommitmentIntervalDay;
    };
    
    /**
     * Executa todos os eventos necessários no eventof
     * "WidgetOnEnterOnce" da widget "CALENDARIO".
     * 
     * @param {object} widget widget "CALENDARIO".
    */
    this.calendarioOnEnterOnce = function(widget, fieldsToApply) {
        
        this.getContainerDefaultActions();
        this.defineIfUserCanSyncGoogle(widget);
        this.setResaleRules(widget);
        evolutionTabController.setEvolutionTabOnActiveWidget(templateManager.container.getWidget('tabbed_evol'));
        
        var filterRow = {};
        filterRow.CDOPERADOR = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        filterRow.NMPARCRESP = templateManager.LOGGEDOPERATOR.NMOPERADOR;
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    };
    
    
    this.setOperadorFilter = function() {
        var widgetFiltro = templateManager.container.getActiveWidget();
        
        widgetFiltro.currentRow.NMPARCRESP = templateManager.LOGGEDOPERATOR.NMPARCRESP;
        widgetFiltro.currentRow.CDOPERADOR = templateManager.LOGGEDOPERATOR.CDOPERADOR;
    };
    
    
    /**
     * Executa todos os eventos necessários no evento
     * "WidgetAfterLoadDataSource" da widget "CALENDARIO".
     * 
     * @param {object} widget widget "CALENDARIO".
    */
    this.widgetAfterLoadDataSource = function(widget) {
        
        this.authenticateUserAndContinueGoogleSysnc(widget).then(function() {
            
            ScreenService.hideLoader();
            this.setCommitmentPermissions(widget);
            this.checkCommitmentsWithInterval(widget);
            if(!syncronized) {
                this.activateGoogleSyncAction();
            } else {
                this.activateGoogleDesyncAction();
            }
            
        }.bind(this))
        .catch(function(error) {
            
            ScreenService.hideLoader();
            this.deleteGoogleCalendarParamInTemplateManager();
            this.deleteSavedGoogleEventsInTemplateManager();
            this.activateGoogleSyncAction();
            ScreenService.showMessage(error); 
            
        }.bind(this));
        
    };
    
    /**
     * Fundi os compromissos recebidos como parâmetro
     * com os já presente na widget.
     * 
     * @param {object} widget widget com os eventos
     * principais.
     * 
     * @param {object} commitments compromissos a serem
     * fundidos.
    */
    this.mergeRelatedCommitmentsAsParticipantWithWidgetData = function(widget, commitments) {
        
        return widget.dataSource.data.concat(commitments);
        
    };
    
    /**
     * Configura as permissões dos compromissos exibidos
     * no calendário.
     * 
     * As permissões são controladas de acordo com o filtro
     * selecionado pelo usuário, os compromissos retornados
     * são configurados de acordo com os operadores filtrados.
     * 
     * Quando um compromisso é exibido no calendário e o operador
     * responsável pelo compromisso não é um operador presente no filtro,
     * realizado pelo usuário, o compromisso é definido como
     * "[RELACIONADO COMO PARTICIPANTE]".
     * 
     * @param {object} widget widget principal da tela de
     * compromissos('CALENDARIO').
    */
    this.setCommitmentPermissions = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var commitments = widget.dataSource.data;
        var filtredOperators = this.getCalendarWidgetOperatorFilter(widget);
        
        commitments.forEach(function(commitment) {
            
            if(Boolean(commitment.CDOPERADOR)) {
                
                if(!this.checkIfOperadorCanToEditCommitment(widget, commitment)) {
                    
                    commitment.NOEDITABLE = true;
                    commitment.BECAUSENOEDITABLE = Messages.NOEDIT_PARTICIPANTE_COMPROMISSO;
                    commitment.REFERENCIA = '[RELACIONADO COMO PARTICIPANTE]';    
                    
                }else if(filtredOperators.indexOf(commitment.CDOPERADOR) === -1 && commitment.CDOPERADOR === loggedOperatorInfos.CDOPERADOR) {
                    
                    commitment.REFERENCIA = '[RELACIONADO COMO PARTICIPANTE]'; 
                    
                }else if(commitment.CDOPERADOR !== loggedOperatorInfos.CDOPERADOR && commitment.CDOPERINCLUSAO !== loggedOperatorInfos.CDOPERADOR && Boolean(loggedOperatorInfos.IDOPERMASTER !== 'S') && loggedOperatorInfos.CDOPERSHIERARQINF.indexOf(commitment.CDOPERADOR) === -1) {
                    
                    commitment.NOEDITABLE = true;
                    commitment.BECAUSENOEDITABLE = Messages.EDICAO_APENAS_RESPONSAVEL;
                    
                }    
                
            }
            
        }.bind(this));
        
        return commitments;
        
    };
    
    /**
     * Retorna um valor lógico indicando se o usuário poderá ou não
     * modificar o compromisso em caso.
     * Se o operador do compromisso não estiver presente no filtro
     * e o operador logado não for o operador responsável pelo compromisso
     * indica que o compromisso é exibido como 'participante' e o operador
     * logado não poderá editá-lo.
     * 
     * Porém, se o operador logado for o criador do compromisso ou um operador
     * master, na hierarquia de operadores, ele será editavel.
     * 
     * @param {object} widget widget de compromisso.
     * 
     * @param {object} commitment compromisso em caso.
     * 
     * @return {boolean} valor lógico indicando se o usuário poderá ou não
     * modificar o compromisso em caso.
     * 
    */
    this.checkIfOperadorCanToEditCommitment = function(widget, commitment) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var filtredOperators = this.getCalendarWidgetOperatorFilter(widget);
        
        if(
            (filtredOperators.indexOf(commitment.CDOPERADOR) !== -1 && 
            commitment.CDOPERADOR !== loggedOperatorInfos.CDOPERADOR) ||
            commitment.CDOPERINCLUSAO === loggedOperatorInfos.CDOPERADOR ||
            Boolean(loggedOperatorInfos.IDOPERMASTER === 'S') ||
            loggedOperatorInfos.CDOPERSHIERARQINF.indexOf(commitment.CDOPERADOR) !== -1
        )
        {
            return true;
        }
        
        return false;
        
    };
    
    /**
     * Retorna os operadores que estão como filtro
     * na widget de compromissos('CALENDARIO'), caso o
     * filtro esteja vazio, a função retorna o operador
     * logado..
     * 
     * @param {object} widget widget principal da tela de
     * compromissos('CALENDARIO').
     * 
     * @return  {object} array com os operadores filtrados.
    */
    this.getCalendarWidgetOperatorFilter = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var widgetFilter = widget.dataSourceFilter;
        var operatorFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(widgetFilter, "CDOPERADOR");
        
        if(!operatorFilterIndex) {
            var operatorFilter = {
                name: "CDOPERADOR",
                operator: "IN",
                value: [loggedOperatorInfos.CDOPERADOR]
            };
            widgetFilter.push(operatorFilter);
            operatorFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(widgetFilter, "CDOPERADOR");
        }
        
        var filter = widgetFilter[operatorFilterIndex].value ? widgetFilter[operatorFilterIndex].value : loggedOperatorInfos.CDOPERADOR;
        var modifiedFilter = this.changeStringAsLoggedOperatorFilter(filter);
        
        return modifiedFilter;
        
    };
    
    /**
     * Altera o filtro de operator caso ele esteja como
     * a string de referência ('@templateManager.LOGGEDOPERATOR.CDOPERADOR@').
     * 
     * @param {object | String} filter filtro a ser verificado.
     * 
     * @return {object | String} filtro configurado.
    */
    this.changeStringAsLoggedOperatorFilter = function(filter) {
        
        if(filter === "@templateManager.LOGGEDOPERATOR.CDOPERADOR@") {
            filter = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        }
        
        return filter;
        
    };
    
    /**
     * Ativa a ação para o usuário sincronizar
     * um calendário google ao sistema.
    */
    this.activateGoogleSyncAction = function() {
        
        this.setGoogleSyncActionVisibility(true);
        this.setGoogleDesyncActionVisibility(false);
        
    };
    
    /**
     * Ativa a ação para o usuário dessincronizar
     * um calendário google ao sistema.
    */
    this.activateGoogleDesyncAction = function() {
        
        this.setGoogleSyncActionVisibility(false);
        this.setGoogleDesyncActionVisibility(true);
        
    };
    
    /**
     * Pergunta ao usuário se ele deseja desativar a 
     * sincronização com o calendário do Google.
     * 
     * @param {object} widget widget principal "CALENDARIO".
    */
    this.desyncTasksWithGoogleCalendarQuestion = function(widget) {
        
        ScreenService.confirmMessage(Messages.DESINC_GOOGLE_CALENDAR, 'question', function(success) {
            
            this.desyncTasksWithGoogleCalendar(widget);
            syncronized = false;
            widget.reload().then(function() {
                ScreenService.showMessage(Messages.GOOGLE_DESINC_SUCESSO);
            });    
            
        }.bind(this));
        
    };
    
    /**
     * Desativa a sincronização com o calendário do Google.
     * 
     * @param {object} widget widget principal "CALENDARIO".
    */
    this.desyncTasksWithGoogleCalendar = function(widget) {
        
        this.deleteGoogleCalendarParamInTemplateManager();
        this.deleteSavedGoogleEventsInTemplateManager();
        this.activateGoogleSyncAction();
        API_GoogleCalendar.signOutGoogle();
        
    };
    
    /**
     * Questiona o usuário se ele deseja sincronizar
     * suas atividades com o calendário vinculado
     * a conta(Gmail) autenticada.
     * 
     * @param {object} widget widget principal "CALENDARIO".
    */
    this.syncTasksWithGoogleCalendar = function(widget) {
    
        ScreenService.confirmMessage(Messages.SINC_GOOGLE_CALENDAR, 'question',
            function (success) {
                
                this.defineParamInTemplateManagerConfirmingGoogleCalendar();
                widget.reload();
                
            }.bind(this),
            function (error) {
            }
        );
        
    };
    
    /**
     * Realiza o processo de autenticação pelo google
     * e continua o processo de sincronização decorrente.
     * 
     * @param {object} widget widget principal "CALENDARIO".
    */
    this.authenticateUserAndContinueGoogleSysnc = function(widget) {
        
        var zhPromise = ZHPromise.defer();
        
        if(Boolean(templateManager.SYNCGOOGLECALENDAR)) {
            
            ScreenService.showLoader();
            return API_GoogleCalendar.signInGoogle()
                .then(function() {
                    
                    this.activateGoogleDesyncAction();
                    syncronized = true;
                    return this.mergeGoogleCalendareEventsToZeedhiCalendarEvents(widget);
                    
                }.bind(this));
        }else{
            
            zhPromise.resolve();
            
        }
        return zhPromise.promise;    
        
    };
    
    /**
     * Mescla os eventos do calendário google
     * do usuário autenticado com os eventos criados
     * pelo calendário zeedhi.
     * 
     * @param {object} zeedhiCalendarWidget widgtet principal
     * com o  calendário zeedhi.
    */
    this.mergeGoogleCalendareEventsToZeedhiCalendarEvents = function(zeedhiCalendarWidget) {
        
        var zhPromise = ZHPromise.defer();
        
        if(Boolean(templateManager.SYNCGOOGLECALENDAR)) {
            var zeedhiCalendarEvents = zeedhiCalendarWidget.dataSource.data;
            
            if(!Boolean(templateManager.GOOGLEEVENTS)) {
                
                return this.createArrayWithLoggedUserGoogleEventsInZeedhiCalendarWidget(zeedhiCalendarWidget).then(function() {
                    zeedhiCalendarWidget.dataSource.data = zeedhiCalendarEvents.concat(templateManager.GOOGLEEVENTS);
                    ScreenService.showMessage(Messages.GOOGLE_SINC_SUCESSO);
                });
                
            }else{
                zeedhiCalendarWidget.dataSource.data = zeedhiCalendarEvents.concat(templateManager.GOOGLEEVENTS);
            }
        }
        
        zhPromise.resolve();
        return zhPromise.promise;
        
    };
    
    /**
     * Deleta os eventos do google salvo no templateManager;
    */
    this.deleteSavedGoogleEventsInTemplateManager = function() {
        
        if(templateManager.GOOGLEEVENTS) {
            delete templateManager.GOOGLEEVENTS;
        }
        
    };
    
    /**
     * Cria um array com os eventos relacionados a agenda
     * do google do usuário autenticado(pelo google) dentro
     * do template manager, excluindo eventos cadastrados pelo
     * CRM e foram incluídos no google calendar(Eventos de seis
     * meses atrás em diante, em consideração a data atual).
    */
    this.createArrayWithLoggedUserGoogleEventsInZeedhiCalendarWidget = function() {
        
        var zhPromise = ZHPromise.defer();
        
        var dateSixMonthAgo = this.getDateSixMonthAgo();
        var googleFormateddateSixMonthAgo = API_GoogleCalendar.createGoogleEventDateTimeFormat(dateSixMonthAgo, '00:00:00');
        
        API_GoogleCalendar.getLoggedGoogleUserEvents(null, googleFormateddateSixMonthAgo).then(function(response) {
            
            templateManager.GOOGLEEVENTS = [];
            response.map(function(event) {
                
                if((!Boolean(event.summary) || event.summary.search("[CRM]") <= 0) && event.status !== 'cancelled') {
                    
                    var initDate = Boolean(event.start.dateTime) ? event.start.dateTime : event.start.date;
                    var endDate = Boolean(event.end.dateTime) ? event.end.dateTime : event.end.date;
                    
                    event.iniDateTime = this.getGoogleEventFormattedDateTime(initDate);
                    event.endDateTime = this.getGoogleEventFormattedDateTime(endDate);
                    
                    templateManager.GOOGLEEVENTS.push(this.createZeedhiCalendarDefaultEvent(event));
                }
                
                return;
                
            }.bind(this));
            
            zhPromise.resolve();
            
        }.bind(this)).catch(function(error) {
            zhPromise.reject(error);
        });
        
        return zhPromise.promise;
        
    };
    
    /**
     * Retorna uma string no formato datetime
     * padrão de acordo com o datetime usado
     * pelo evento do google.
     * 
     * @param {string} googleDateTime datetime usado
     * nos eventos do google.
    */
    this.getGoogleEventFormattedDateTime = function(googleDateTime) {
        
        var date;
        var time;
        
        if(googleDateTime.length <= 10) {
            
            date = moment(googleDateTime, 'YYYY-MM-DD').format('DD/MM/YYYY');
            time = '00:00';
            
        }else{
            
            date = moment(googleDateTime.substr(0,10), 'YYYY-MM-DD').format('DD/MM/YYYY');
            time = googleDateTime.substr(11,5);
            
        }
        
        return date + ' ' + time;
        
    };
    
    /**
     * Retornar um objecto padrão para o ser inserido
     * ao data source de uma calendário zeehdi(scheduler).
     * 
     * @param {object} event evento referência para criar o 
     * objeto.
     * 
     * @param {object} objeto pardrão para ser inserido
     * no data source do calendário zeedhi.
    */
    this.createZeedhiCalendarDefaultEvent = function(event) {
        
        var isEventDuringTheWholeDay = this.checkEventsDuringTheWholeDay(event);
        
        if(isEventDuringTheWholeDay) {
            event = this.defineEventDuringTheWholeDay(event);
        }
        
        var iniDate = CRM_Utilities.getDateInDateTime(event.iniDateTime);
        var endDate = CRM_Utilities.getDateInDateTime(event.endDateTime);
        var iniTime = CRM_Utilities.getTimeInDateTime(event.iniDateTime);
        var endTime = CRM_Utilities.getTimeInDateTime(event.endDateTime);
        
        var eventTitle = event.summary ? event.summary.toUpperCase() : '(SEM TÍTULO)';
        var eventDuration = iniTime + ' - ' + endTime;
        var eventDescription = event.description ? event.description : "";
        var reference = "[COMPROMISSO REFERENTE A AGENDA DO EMAIL: " + event.creator.email.toUpperCase() + ']';
        
        if(isEventDuringTheWholeDay) {
            endDate = iniDate;
            eventDuration = 'Duranto Todo o Dia';
        }
        
        var googleEvent = {
            DATAINI: iniDate,
            DATAFIN: endDate,
            HRINICONCATFIN: eventDuration,
            HORAINI: iniTime,
            HORAFIN: endTime,
            DTINI: iniDate + ' às ' + iniTime,
            DTFIM: endDate + ' às ' + endTime,
            DTINIPLANOCUPA: event.iniDateTime,
            DTFINPLANOCUPA: event.endDateTime,
            TITULOEVENTOGOOGLE: eventTitle,
            STATUSPLANOCUPA: "Aceito",
            IDATIVO: 'S',
            DSCAMINHOICONE: "https://crm.teknisa.com/assets/images/icons/list.png",
            DSCORCARD: "#6fe88b",
            REFERENCIA:  reference,
            DSPLANOCUPA: reference + ' ' + eventDescription,
            NOEDITABLE: true,
            BECAUSENOEDITABLE: Messages.IMPOSSIVEL_MANUSEAR_EVENTO_GOOGLE,
            GOOGLEEVENT: true,
            __isSelected: false,
            __is_new: false
        };
        return googleEvent;
        
    };
    
    /**
     * Verifica se a variável de início do
     * evento é denominada 'date'.
     * Quando uma variável possui esta denominação,
     * significa que o compromisso dura o dia inteiro.
     * 
     * @param {event} event objecto com as informações do
     * evento.
    */
    this.checkEventsDuringTheWholeDay = function(event) {
        
        if(Boolean(event.start.date)) {
            return true;
        } else {
            return false;
        }
        
    };
    
    /**
     * Seta as configuraçãoes de um evento para ser
     * representado como um evento de um dia interio.
     * 
     * @param {object} event objeto com as informações
     * do evento em cas.
     * 
     * @return {object} evento configurado.
    */
    this.defineEventDuringTheWholeDay = function(event) {
        
        event.endDateTime = event.iniDateTime;
        
        return event;
        
    };
    
    /**
     * Defini a utilização do calendário do
     * google.
    */
    this.defineParamInTemplateManagerConfirmingGoogleCalendar = function() {
        templateManager.SYNCGOOGLECALENDAR = true;
    };
    
    /**
     * Delete o parâmetro no template manager que
     * indica o uso do calendário do google.
    */
    this.deleteGoogleCalendarParamInTemplateManager = function() {
        
        if(Boolean(templateManager.SYNCGOOGLECALENDAR)) {
            delete templateManager.SYNCGOOGLECALENDAR;
        }
        
    };
    
    /**
     * Adiciona um evento a agenda do usuário logado
     * (pela autenticação do Google).
     * 
     * @param {object} event compromisso que será
     * utilizado como referência para a inserção do
     * compromisso na agenda do google.
    */
    this.addEventToLoggedUserGoogleCalendar = function(event) {
        
        ScreenService.confirmMessage(Messages.QUESTAO_INSERIR_COMPROMISSO_GOOGLE, 'question',
        function(success) {
            
            var googleEventObject = this.createGoogleEventObject(event);
            
            API_GoogleCalendar.addGoogleEvent(googleEventObject)
            .then(function(response) {
                ScreenService.showMessage(Messages.COMPROMISSO_INSERIDO_GOOGLE);
            }.bind(this))
            .catch(function() {
                ScreenService.showMessage(Messages.COMPROMISSO_NAO_INSERIDO_GOOGLE);
            });
            
        }.bind(this));
    };
    
    /**
     * Adiciona um evento a agenda do usuário logado
     * (pela autenticação do Google).
     * 
     * @param {object} event compromisso que será
     * utilizado como referência para a inserção do
     * compromisso na agenda do google.
    */
    this.addEventToLoggedUserGoogleCalendarWithoutQuest = function(event) {
            
            var googleEventObject = this.createGoogleEventObject(event);
            
            API_GoogleCalendar.addGoogleEvent(googleEventObject)
            .then(function(response) {
                ScreenService.showMessage(Messages.COMPROMISSO_INSERIDO_GOOGLE);
            }.bind(this))
            .catch(function() {
                ScreenService.showMessage(Messages.COMPROMISSO_NAO_INSERIDO_GOOGLE);
            });
        
    };
    
    /**
     * Cria um objeto padrão Google para ser inserido
     * no Google calendar.
     * 
     * @param {object} event objeto com as informações
     * para criar o objeto padrão Google.
    */
    this.createGoogleEventObject = function(event) {
        
        var googleEventObject = {
            ID: event.NRSEQPLANOCUPA,
            TITLE: '[CRM] - ' + event.NMPRINCIPALPARC,
            INITDATE: CRM_Utilities.getDateInDateTime(event.DTINIPLANOCUPA),
            INITTIME: CRM_Utilities.getTimeInDateTime(event.DTINIPLANOCUPA),
            ENDDATE: CRM_Utilities.getDateInDateTime(event.DTFINPLANOCUPA),
            ENDTIME: CRM_Utilities.getTimeInDateTime(event.DTFINPLANOCUPA),
            DESCRIPTION: event.DSPLANOCUPA
        };
        
        return googleEventObject;
        
    };
    
    /**
     * Função para editar um evendo no google.
     * 
     * @param {object} event object com as informações 
     * base para realizar a edição. 
    */
    this.editGoogleEvent = function(event) {
        
        var googleEventObject = this.createGoogleEventObject(event);
        
        API_GoogleCalendar.editGoogleEvent(googleEventObject).then(function() {
            ScreenService.showMessage(Messages.GOOGLE_EVENTO_EDITADO_SUCESSO);
        });
        
    };
    
    /**
     * Define se o usuário terá a possibilidade
     * de sincronizar o Google Calendar a sua agenda
     * de acordo com a parametrização do CRM.
     * 
     * @param {object} widget widget principal "CALENDARIO".
    */
    this.defineIfUserCanSyncGoogle = function(widget) {
        
        var crmParametrization = CRM_Utilities.getCrmParametrization();
            
        if(crmParametrization.IDPERMITESINCGOOGLE === 'S') {
            this.setGoogleSyncActionVisibility(true);
        }
        
    };
    
    /**
     * Define se a ação "Sincronizar Google" será visível ao
     * usuário.
     * 
     * @param {boolean} isVisible valor lógico para definir
     * visibilidade.
    */
    this.setGoogleSyncActionVisibility = function(isVisible) {
        var actions = templateManager.container.actions;
        var syncActionIndex = CRM_Utilities.getObjectPositionInArrayByName(actions, 'SINC_GOOGLE');
        
        templateManager.container.actions[syncActionIndex].isVisible = isVisible;
    };
    
    /**
     * Define se a ação "Dessincronizar Google" será visível ao
     * usuário.
     * 
     * @param {boolean} isVisible valor lógico para definir
     * visibilidade.
    */
    this.setGoogleDesyncActionVisibility = function(isVisible) {
        var actions = templateManager.container.actions;
        var desyncActionIndex = CRM_Utilities.getObjectPositionInArrayByName(actions, 'DESSINC_GOOGLE');
        
        templateManager.container.actions[desyncActionIndex].isVisible = isVisible;
    };
    
    /**
     * Define as regras da tela de compromisso de acordo 
     * com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela de compromisso
     * ('CALENDARIO').
    */
    this.setResaleRules = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)) {
            
            var restrictObjects = [];
            
            restrictObjects.push(widget);
            restrictObjects.push(widget.getField("NMOPERADOR"));
            
            var newCommitmentWidget = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
            restrictObjects.push(newCommitmentWidget.getField("NMOPERADORESPONS"));
            restrictObjects.push(newCommitmentWidget.getField("NMPRINCIPALPARC"));
            
            var commitmentParticipantsWidget = templateManager.container.getWidget('WDGT_COMMITMENT_PARTICIPANTS');
            restrictObjects.push(commitmentParticipantsWidget.getField("CDOPERADORPART"));
            
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);
            
        }
    };
    
    this.changeOperatorFilter = function(args) {
        
        var widget = args.owner;
        var cdoperador = widget.__filterPopup.currentRow.CDOPERADOR;
        var filtros = widget.dataSourceFilter;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var allOperators = true;
        
        //2 = Quantidade padrão de filtros, ou seja, se algo foi filtrado
        if(filtros.length !== 3) {
            filtros.forEach(function(filtro) {
                //Se filtrou operador
                if(filtro.name === "CDOPERADOR") {
                    allOperators = false;
                }
            });
        }else{
            //Se nada foi filtrado operador logado é o padrão
            var defaultOperator = {};
            defaultOperator.name = "CDOPERADOR";
            defaultOperator.operator = "IN";
            defaultOperator.value = [loggedOperatorInfos.CDOPERADOR];
            defaultOperator.static = true;
            filtros.push(defaultOperator);
            allOperators = false;
        }
        //Se algo foi filtrado e operador não foi setado, todos é o padrão
        if(allOperators) {
            allOperators = {};
            allOperators.name = "CDOPERADOR";
            allOperators.operator = "IS_NOT_NULL";
            allOperators.static = true;
            filtros.push(allOperators);    
        }
        
    };
    
    /**
     * Define o filtro dos campos de parceiro de negócio
     * do container.
     * 
     * @param {widget} widget widget principal da tela 
     * de compromissos.
    */
    this.setNegotiationPartnerFieldFilter = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        var newCommitmentWidget = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        
        var fields = [];
        fields.push(widget.getField('NMPRINCIPALPARC'));
        fields.push(newCommitmentWidget.getField('NMPRINCIPALPARC'));
        
        var fieldFilter;
        var nrorgFilterIndex;
        var nrparcnegocioFilterIndex;
        
        fields.forEach(function(field) {
            
            fieldFilter = field.dataSourceFilter;
            nrorgFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(fieldFilter, "P_NRORG");
            nrparcnegocioFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(fieldFilter, "P_NRPARCNEGOCIO");
            
            fieldFilter[nrorgFilterIndex].value = loggedOperatorInfos.NRORG;
            fieldFilter[nrparcnegocioFilterIndex].value = loggedOperatorInfos.NRPARCNEGOCIO;    
            
        });
        
    };
    
    /**
     * Abri o swipe para adicionar um novo participante
     * ao compromisso.
     * 
     * @param {object} widget widge de participantes
     * ("WDGT_COMMITMENT_PARTICIPANTS").
    */
    this.addCommitmentParticipant = function(widget) {
        
        var eventCurrentRow = templateManager.container.getWidget('WDGT_NEW_COMMITMENT').currentRow;
        
        if(!Boolean(eventCurrentRow.NOEDITABLE)) {
            General.widgetNewRow(widget);
        } else {
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(eventCurrentRow.BECAUSENOEDITABLE));
        }
        
    };
    
    /**
     * Delete um participante de um compromisso.
     * 
     * @param {object} widget widge de participantes
     * ("WDGT_COMMITMENT_PARTICIPANTS").
    */
    this.deleteCommitmentParticipant = function(widget) {
        
        var eventCurrentRow = templateManager.container.getWidget('WDGT_NEW_COMMITMENT').currentRow;
        
        if(!Boolean(eventCurrentRow.NOEDITABLE)) {
            General.deleteCrud(widget);
        } else {
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(eventCurrentRow.BECAUSENOEDITABLE));
        }
        
    };
    
    /**
     * Abre a tab de evolução como swipe de form
    */
    this.openTabEvolucao = function(widget) {
        var widgetEvolucao = templateManager.container.getWidget('WDGT_EVOLUCAO');        
        var widgetCompromisso = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        if(Util.isEmptyOrBlank(widgetCompromisso.currentRow.DTREALFECHA)) {
            this.setCurrentRow(widgetEvolucao);
            ScreenService.openSwipe(widgetEvolucao.parent).then(function() {
                widgetEvolucao.template = "widget/form.html";
                widgetEvolucao.mode = "edit";
                widgetEvolucao.edit();
                widgetEvolucao.formTemplate = "widget/form.html";
                //Garantindo que os métodos do general irão funcionar
                widgetEvolucao.backupRow = angular.copy(widgetEvolucao.currentRow);
                ScreenService.closePopup(true);
                widgetEvolucao.activate();
                evolutionTabController.overwriteAction('BACK_EDIT', "crm30000000_Compromisso_Controller.cancelEvol(args.owner.widget)");
                var methods = [
                    "ScreenService.closeSwipe(true)",
                    "templateManager.container.getWidget('WDGT_NEW_COMMITMENT').activate()"
                ];
                evolutionTabController.setMethodsAfterSave(methods);
                if(widgetCompromisso.currentRow.TIPO === 'OPORTUNIDADE') {
                    this.createOportFields();
                    evolutionTabController.overwriteAction('SAVE', "crm00002001_OportunidadeNegocio_Controller.confirmClosingOpportunityBeforeSaveEvolution(args.owner.widget)");
                    widgetEvolucao.dataSource.name = "product#/evolcont_crm_oportuni";
                    evolutionTabController.showFieldGroup(true);
                }else{
                    evolutionTabController.hideFieldGroup(true);
                    evolutionTabController.defaultAction('SAVE');
                    widgetEvolucao.dataSource.name = "/evolcont_contato";
                }
            }.bind(this));
        }else{
            ScreenService.showMessage(Messages.IMPOSSIVEL_MANUSEAR_EVENTO(Messages.OPORTUNIDADE_FECHADA));    
        }
    };
    
    /**
     * Metodo para sobreescrever a action de cancel da tab
     * dinânica, adaptando para form.
    */
    this.cancelEvol = function(widget) {
        var widgetCompromisso = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        General.widgetCancelForm(widget);
        ScreenService.closeSwipe();
        widgetCompromisso.activate();
    };
    
    /**
     * Seta os valores default da tab de evolução
    */
    this.setCurrentRow = function(widget) {
        //Limpa a currentRow
        Object.keys(widget.currentRow).forEach(function(key) {
           widget.currentRow[key] = ''; 
        });
        
        var widgetCompromisso = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        if(Util.isEmptyOrBlank(widgetCompromisso.currentRow.NRSEQCONTATO)) {
            var params = {
                'requestType':'Row',
                'row': {"NRPARCNEGOCIO": widgetCompromisso.currentRow.NRPARCNEGOCIO, "NRORG": widgetCompromisso.currentRow.NRORG}
            };
            restEngine.post('/selectProspectNrContato', params,
                function(success) {
                    widget.currentRow.NRSEQCONTATO = success.dataset.DADOS.NRSEQCONTATO;
                    widget.currentRow.NRCONTATO = success.dataset.DADOS.NRSEQCONTATO;
                });
        }else{
            widget.currentRow.NRSEQCONTATO = widgetCompromisso.currentRow.NRSEQCONTATO;
            widget.currentRow.NRCONTATO = widgetCompromisso.currentRow.NRSEQCONTATO;
        }
        widget.currentRow.DTHREVOLCONT = CRM_Utilities.getDataHoraAtual();
        widget.currentRow.IDSENEVOCONT = 'S';
        widget.currentRow.CDOPEREVOL = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        widget.currentRow.NMOPERADOR = templateManager.LOGGEDOPERATOR.NMOPERADOR;
        widget.currentRow.DSFILACONTATO = 'Retornar contato';
        widget.currentRow.NMOPERADORREAL = templateManager.LOGGEDOPERATOR.NMOPERADOR;
        widget.currentRow.CDOPERREAL = templateManager.LOGGEDOPERATOR.CDOPERADOR;
        widget.currentRow.NRPARCNEGOCIO = widgetCompromisso.currentRow.NRPARCNEGOCIO;
        widget.currentRow.NRORG = widgetCompromisso.currentRow.NRORG;
        widget.NRSEQOPORT = widgetCompromisso.currentRow.NRSEQOPORT;
        widget.currentRow.NRSEQOPORT = widgetCompromisso.currentRow.NRSEQOPORT;
        widget.parent.parent.currentRow.NRSEQOPORT = widgetCompromisso.currentRow.NRSEQOPORT;
        widget.parent.parent.currentRow.NRPARCNEGOCIO = widgetCompromisso.currentRow.NRPARCNEGOCIO;
        widget.currentRow.__is_new = true;
    };
    
    
    /**
     * Muda a Action de acordo com o tipo do compromisso
    */
    this.changeActionLabel = function(widget) {
        var actionEvolucao = widget.getAction('EVOLUIR');
        var currentRow = widget.currentRow;
        
        if(Util.isEmptyOrBlank(currentRow.TIPO)) {
            actionEvolucao.isVisible = false;
        }else if(!Util.isEmptyOrBlank(currentRow.NRSEQOPORT)) {
            actionEvolucao.label = 'Evoluir Oportunidade';
            actionEvolucao.isVisible = true;
        } else {
            actionEvolucao.label = 'Evoluir Parceiro';
            actionEvolucao.isVisible = true;
        }
        
    };
    /**
     * Cria o json dos fields de oportunidade e builda na tab de evolução
    */
    this.createOportFields = function() {
        //dados oport
        var fieldsDadosOportunidade = [
            {
                "name": "NMSEQFASENEGO",
                "label": "Fase de Negociação",
                "fieldGroup": "FG_DADOS_OPORTUNIDADE",
                "template": "field/select.html",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "class": "6",
                "dataSource": {
                    "name": "product#/crm_fasenegoci_operador",
                    "rest": true,
                    "lazyLoad": true
                },
                "itemsPerPage": 50,
                "valueField": "NRSEQFASENEGO",
                "descriptionField": "NMSEQFASENEGO",
                "outData": {
                    "NRSEQFASENEGO": "NRSEQFASENEGO",
                    "NMSEQFASENEGO": "NMSEQFASENEGO",
                    "IDPERMITEFECHA": "IDPERMITEFECHA",
                    "IDEXIGEVROPORT": "IDEXIGEVROPORT"
                },
                "validations": {
                    "required": true
                },
                "showSelectAs": "grid",
                "fields": [
                    {
                        
                        "name": "NMSEQFASENEGO",
                        "label": "Fase de Negociação",
                        "showOnList": true,
                        "isVisible": true,
                        "template": "field/text-edit.html"
                    }
                ],
                "events": [
                    {
                        
                        "name": "FieldOnChange",
                        "code": "crm00002001_OportunidadeNegocio_Controller.setClosingDataGroupLockByNegotiationPhase(args.owner.field.widget); crm00002001_OportunidadeNegocio_Controller.setOpportunityValueObligatorinessByNegotiationPhase(args.owner.field.widget);"
                    }
                ]
            },
            {
                
                "name": "VRPREVOPORT",
                "label": "Valor Previsto da Oportunidade",
                "template": "field/text-edit.html",
                "class": "6",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "fieldGroup": "FG_DADOS_OPORTUNIDADE",
                "validation": {},
                "mask": {
                    "type": "currency",
                    "params": {
                        "decimal": ",",
                        "thousands": "."
                    }
                },
                "defaultValue": "@General.getFieldValue('VRPREVOPORT', 'oportunidadegrid')@",
                "events": [],
                "filterProperties": {
                    "isVisible": false,
                    "showOnForm": false,
                    "showOnList": false
                }
            },
            {
                
                "name": "NMPARCRESP",
                "label": "Novo Operador Responsável",
                "fieldGroup": "FG_DADOS_OPORTUNIDADE",
                "template": "field/select.html",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "class": "12",
                "dataSource": {
                    "name": "product#/crud/operador_crm_operrevenda",
                    "rest": true,
                    "lazyLoad": true
                },
                "itemsPerPage": 50,
                "dataSourceFilter": [
                    {
                        "name": "IDTPOPERADOR",
                        "operator": "=",
                        "value": "E"
                    }
                ],
                "showSelectAs": "grid",
                "fields": [
                    {
                        
                        "name": "NMOPERADOR",
                        "label": "Nome",
                        "showOnList": true
                    }
                ],
                "valueField": "NRPARCRESP",
                "descriptionField": "NMPARCRESP",
                "outData": {
                    "NRPARCNEGOCIO": "NRPARCRESP",
                    "NMOPERADOR": "NMPARCRESP",
                    "CDOPERADOR": "CDOPERADOR"
                },
                "validations": {},
                "filterProperties": {}
            }
        ];
        evolutionTabController.buildDynamicFieldGroup(fieldsDadosOportunidade, "FG_DADOS_OPORTUNIDADE", "Dados da Oportunidade");
        
        //fechamentoOport
        var fieldsFechaOportunidade = [
            {
                "name": "DTREALFECHA",
                "label": "Data de Fechamento",
                "template": "field/datetime.html",
                "isVisible": true,
                "showOnView": true,
                "showOnForm": true,
                "readOnly": true,
                "fieldGroup": "FG_DADOS_FECHAMENTO",
                "class": "4",
                "validations": {},
                "events": []
            },
            {
                "name": "DESCRESULEVOL",
                "label": "Resultado",
                "template": "field/select.html",
                "showSelectAs": "grid",
                "isVisible": true,
                "showOnForm": true,
                "class": "4",
                "fieldGroup": "FG_DADOS_FECHAMENTO",
                "valueField": "NRSEQRESULEVOL",
                "descriptionField": "DESCRESULEVOL",
                "validations": {},
                "dataSource": {
                    "name": "product#/crm_resultevol_crm_perfiresult_crm_perfioper",
                    "rest": true,
                    "lazyLoad": true
                },
                "itemsPerPage": 50,
                "dataSourceFilter": [
                    {
                        "name": "P_NRORG",
                        "operator": "=",
                        "value": ""
                    },
                    {
                        "name": "P_CDOPERADOR",
                        "operator": "=",
                        "value": ""
                    },
                    {
                        "name": "IDRESULTOPORTUNI",
                        "operator": "=",
                        "value": "SIM"
                    }
                ],
                "fields": [
                    {
                        "name": "DESCRESULEVOL",
                        "label": "Resultado",
                        "showOnList": true,
                        "isVisible": true,
                        "template": "field/text-edit.html"
                    }
                ],
                "outData": {
                    "NRSEQRESULEVOL": "NRSEQRESULEVOLOPORT",
                    "DESCRESULEVOL": "DESCRESULEVOL"
                },
                "events": [
                    {
                        "name":"FieldAfterSelectOpen",
                        "code":"crm00002001_OportunidadeNegocio_Controller.setResultFieldFilter(args.owner.field);args.owner.field.reload()"
                    }
                ]
            },
            {
                "name": "VROPORT",
                "label": "Valor da Oportunidade",
                "template": "field/text-edit.html",
                "class": "4",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "fieldGroup": "FG_DADOS_FECHAMENTO",
                "validation": {},
                "mask": {
                    "type": "currency",
                    "params": {
                        "decimal": ",",
                        "thousands": "."
                    }
                },
                "events": [],
                "filterProperties": {
                    "isVisible": false,
                    "showOnForm": false,
                    "showOnList": false
                }
            },
            {
                "name": "NMRAZSOCCONC",
                "label": "Concorrente Vencedor da Negociação",
                "template": "field/select.html",
                "isVisible": true,
                "showOnView": true,
                "showOnForm": true,
                "class": "12",
                "fieldGroup": "FG_DADOS_FECHAMENTO",
                "dataSource": {
                    "name": "product#/crm_concorrente",
                    "rest": true,
                    "lazyLoad": true
                },
                "itemsPerPage": 50,
                "dataSourceFilter": [],
                "showSelectAs": "grid",
                "fields": [
                    {
                        "name": "NMRAZSOCCONC",
                        "label": "Razão Social",
                        "showOnList": true
                    },
                    {
                        "name": "NMFANTCONN",
                        "label": "Nome Fantasia",
                        "showOnList": true
                    }
                ],
                "valueField": "NRCONCORRENTE",
                "descriptionField": "NMRAZSOCCONC",
                "outData": {
                    "NRCONCORRENTE": "NRCONCORRENTE",
                    "NMRAZSOCCONC": "NMRAZSOCCONC"
                }
            }
        ];
        evolutionTabController.buildDynamicFieldGroup(fieldsFechaOportunidade, "FG_DADOS_FECHAMENTO", "Dados do Fechamento");
    };
    
    this.findCalendarWidgetThroughList = function(listWidget) {
        var calendarWidget = listWidget.getParent().widgets.find(function(x) {
            return x.name == 'CALENDARIO';
        });
        return calendarWidget;
    };
    
    this.listOnEnter = function(widget) {
        widget.reload();  
    };
    
    this.askToNotifyInterloc = function() {
        var zhPromise = ZHPromise.defer();
        var message = 'Deseja selecionar um interlocutor para ser notificado?';
        
        ScreenService.confirmMessage(message, 'question', zhPromise.resolve);
        
        return zhPromise;
    };
    
    this.openSwipeNotifyInterloc = function(newCommitWidget) {
        var notifyWidget = templateManager.container.getWidget('WDGT_NOTIFY_INTERLOC');
    
        return ScreenService.openSwipe(notifyWidget).then(function() {
            notifyWidget.activate();
            notifyWidget.edit();
        });
    };
    
    this.closeInterlocNotify = function() {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.closeSwipe();
        widget.parent.widgets[0].widgets[0].activate()
    };
    
    this.notifyInterloc = function() {
        var widget = templateManager.container.getActiveWidget();
        var widgetPai = templateManager.container.getWidget('WDGT_NEW_COMMITMENT');
        
        if(widget.isValid()) {
            var currentRow = widget.currentRow;
            
            var commitmentInterlocs = currentRow.NRSEQINTERLOCUTOR;
            var rows = [];
            
            commitmentInterlocs.forEach(function(operator, interlocIndex) {
                
                rows.push(this.setCommitmentInterlocValues(widget, interlocIndex));
                    
            }.bind(this));
        
            General.callRestEngine("product#/notifyInterloc", 'DataSet', rows).then(function(data) {
                if(!Util.isUndefined(data.messages) && data.messages[0].type === "success") {
                    ScreenService.showMessage(data.messages[0].message);
                    ScreenService.closeSwipe();
                    widgetPai.activate();
                } else{
                    ScreenService.showMessage(Messages.SAVE_ROW_ERROR);
                }
            }.bind(this));
            
        }
    };
    
    /**
     * Cria uma cópia da currentRow da widget
     * recebida, define os valores do participante
     * na cópia e a retorna.
     * 
     * @param {object} widget - widget ativa onde está
     * sendo realizado o cadastro do participante.
     * 
     * @param {int} interloctIndex - index do participante
     * nos arrays relacionados ao participantes selecionados
     * na field.
     * 
     * @return {obeject} currentRow cópia da currentRow 
     * da widget recebida como parâmetro, com os valores
     * do participante em caso.
    */
    this.setCommitmentInterlocValues = function(widget, interlocIndex) {
        
        var currentRow = angular.copy(widget.currentRow);
        var commitmentWidgetCurrentRow = this.getCommitmentWidgetCurrentRow();
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRPARCNEGOCIO = currentRow.NRPARCNEGOCIO[interlocIndex];  
        currentRow.NRSEQPLANOCUPA = commitmentWidgetCurrentRow.NRSEQPLANOCUPA;
        currentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
        currentRow.CDOPERADOR = currentRow.CDOPERADOR[interlocIndex];
        currentRow.NMINTERLOCUTOR = currentRow.NMINTERLOCUTOR[interlocIndex];
        currentRow.DATACOMPROMISSO = commitmentWidgetCurrentRow.DTINIPLANOCUPA;
        currentRow.DATAFINAL = commitmentWidgetCurrentRow.DTFINPLANOCUPA;
        currentRow.REFERENCIA = commitmentWidgetCurrentRow.DSREF ? commitmentWidgetCurrentRow.DSREF : "";
        currentRow.MOTIVO = commitmentWidgetCurrentRow.NMMOTIEVOCON;
        currentRow.PARCEIRO = commitmentWidgetCurrentRow.NMPRINCIPALPARC;
        currentRow.OPERADOR = loggedOperatorInfos.NMOPERADOR;
        currentRow.EMAILINTERLOC = currentRow.EMAILINTERLOC[interlocIndex];
        currentRow.NRSEQINTERLOCUTOR = currentRow.NRSEQINTERLOCUTOR[interlocIndex];
        currentRow.TIPO = commitmentWidgetCurrentRow.TIPO;
        
        
        return currentRow;
    };
    
    /**
     * Função para receber a currentRow no compromisso
     * em caso.
     * 
     * @return {object} currentRow currentRow da widget
     * do compromisso em caso.
    */
    this.getCommitmentWidgetCurrentRow = function() {
        
        var commitmentWidget = templateManager.container.getWidget("WDGT_NEW_COMMITMENT");
        
        return commitmentWidget.currentRow;
        
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm30000000_Compromisso_Controller', crm30000000_Compromisso_Controller);
});