function Utilities(ScreenService, templateManager, wizardEngine) { //ZhGrifFilter removido

    var self = this;

    self.changeWidgetVisibility = function(widgets, isVisible) {
        widgets.forEach(function(widget){
            widget.isVisible = isVisible;
        });
    };

    self.formChangeTemplate = function() {
        var widget = templateManager.container.getActiveWidget();

        if((widget.template != "widget/form.html")&&(widget.template != "widget/form-view.html")) return false;

        if(!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if(!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if(widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if(widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };

    self.insertFilter = function(requirer, name, operator, value, position)
    {
        var object = {"name": name, "operator": operator, "value": value};

        if(position == -1)
        {
            if(requirer.dataSourceFilter && requirer.dataSourceFilter.length > 0)
            {
                requirer.dataSourceFilter[dataSourceFilter.length] = object;
            }
            else if(requirer.dataSourceFilter)
            {
                requirer.dataSourceFilter[0] = object;
            }
            else
            {
                requirer.dataSourceFilter = [object];
            }
        }
        else
        {
            requirer.dataSourceFilter[position] = object;
        }

        requirer.reload();

    };
    
    /**
     * Insere um objeto no dataSourceFilter
     * 
     * @param {Object} requirer Objeto que possui o dataSourceFilter a ser modificado.
     * @param {string} name Valor da propriedade "name" do dataSourceFilter.
     * @param {string} operator Valor da propriedade "operator" do dataSourceFilter.
     * @param {string} value Valor da propriedade "value" do dataSourceFilter.
     * @param {number} position Posição em que o objeto será inserido no dataSourceFilter.
     */
    this.insertFilterWithoutReload = function(requirer, name, operator, value, position)
    {
        var object = {"name": name, "operator": operator, "value": value};

        if (position < 0) {
            if (requirer.dataSourceFilter) {
                requirer.dataSourceFilter[requirer.dataSourceFilter.length] = object;
            }
            else {
                requirer.dataSourceFilter = [object];
            }
        }
        else {
            requirer.dataSourceFilter[position] = object;
        }
    };

    self.goBackToDashboard = function() {
        ScreenService.openWindow('dashboard');
    };

    self.masterDetailCancelForm = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            if(!self.formChangeTemplate()) widget.list();
            else widget.list();

            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            self.formChangeTemplate();
            widget.view();
        }
    };

    self.masterDetailClosePopup = function() {
        var popup = templateManager.container.getActiveWidget();

        ScreenService.closePopup();
        popup.deactivate();
        popup.parentWidget.currentWidget = popup.parentWidget;
        popup.parentWidget.activate();
    };

    self.masterDetailDelete = function() {
        try {
            var widget = templateManager.container.getActiveWidget();
            ScreenService.confirmMessage("Deseja deletar o registro?", "CONFIRMATION", function() {
                widget.remove();
                self.masterDetailGoBackToList();
                ScreenService.showMessage("Registro excluído com sucesso");
            }.bind(this));
        } catch (e) {
            ScreenService.showMessage(e, 'ERROR');
        }
    };

    self.masterDetailEdit = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, false);
        self.formChangeTemplate();

        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };

    self.masterDetailGoBackToList = function() {
        var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe();
        widget.list();
    };

    self.masterDetailGoBackToParent = function() {
        var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe().then(function(){
            widget.parent.list();
            widget.parent.activate();
        });
    };

    self.masterDetailNewRow = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, false);

        widget.newRow();
    };

    self.masterDetailOpenPopup = function(name) {
        var widget = templateManager.container.getActiveWidget();

        var popup = widget.container.getWidget(name);
        popup.parentWidget = widget;
        ScreenService.openPopup(popup);
        //ZhGridFilter.startFiltering();
        /*var x = templateManager.container.getActiveWidget().name;
        ZhGridFilter.startSavingFilter(x, true);*/
    };

    self.masterDetailSave = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, true);
        self.formChangeTemplate();

        if(widget.isValid()) {
            widget.currentRow.changed = true;

            return widget.saveRow().then(function(response){
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                ScreenService.showMessage("Registro salvo com sucesso");
                ScreenService.closeSwipe();
                widget.list();
                widget.reload();
            });
        }
    };

    self.unMask = function(columnName) {
        var widget = templateManager.container.getActiveWidget();

        if(widget.currentRow[columnName] && typeof widget.currentRow[columnName] === 'string' && widget.currentRow[columnName].indexOf('R$') != -1)
            widget.currentRow[columnName] = $.currency.unmaskString(widget.currentRow[columnName], {"thousands": "."});
        if(widget.currentRow[columnName] && typeof widget.currentRow[columnName] === 'string' && widget.currentRow[columnName].indexOf('%') != -1)
            widget.currentRow[columnName] = parseFloat(widget.currentRow[columnName].replace(',', '.'));
    };

    self.wizardChangeFooter = function() {
        var widget = templateManager.container.getActiveWidget();

        widget.container.footer = (widget.container.footer == "component/footer.html")?
            "component/footer-wizard.html" : "component/footer.html";
    };

    self.wizardGoBack = function(){
    	wizardEngine.previous();
    };

    self.wizardGoNext = function(){
        wizardEngine.next();
    };

    self.getValorEmReais = function(value)
    {
        var pad = "00";
        var valorFatura = value.split('.');

        if(valorFatura[1] === undefined)
        {
            valorFatura[1] = "";
        }
        valorFatura[1] = String(valorFatura[1]) + pad.substring(0, pad.length - String(valorFatura[1]).length);

        if(valorFatura[0] === '')
        {
            valorFatura[0] = "0";
        }
        var aux = "";
        for(var i = valorFatura[0].length - 1; i >= 0; i--)
        {
            if(((valorFatura[0].length -1 - i)%3 === 0) && (valorFatura[0].length -1 != i))
            {
                aux += ".";
            }
            aux += valorFatura[0][i];
        }

        aux = aux.split("").reverse().join("");
        var valorEmReais = "R$ "+aux+","+valorFatura[1];
        return valorEmReais;
    };

    self.validateFilterPopup = function(args)
    {
        var filterPopup = templateManager.currentWidget;
        if(!filterPopup.isValid())
            args.e.preventDefault();
    };

    self.showErrorMessage = function(error) {
        if(typeof error === 'object') {
            if(error.message) {
                ScreenService.showMessage(error.message, 'error', 'error');
            } else {
                ScreenService.showMessage(error.data.error, 'error', 'error');
            }
        } else {
            ScreenService.showMessage(error, 'error', 'error');
        }
    };
    
    self.masterDetailVoltarList = function(widget) {
        widget.list();
        ScreenService.closeSwipe();
        widget.activate();
    };

    self.masterDetailEdit = function() {
        var widget = templateManager.container.getActiveWidget();
        self.changeWidgetVisibility(widget.widgets, false);
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };
    
    this.changeTemplateToEdit = function(args) {
        var widget = args.owner.widget;
        widget.template = 'widget/form.html';
        widget.edit();
        widget.backupRow = widget.currentRow;
    };

    this.changeTemplateToView = function(args) {
        var widget = args.owner.widget;
        widget.template = 'widget/form-view.html';
        widget.list();
    };
    
    this.changeTemplateToViewOnCancel = function(args) {
        var widget = args.owner.widget;
        widget.template = 'widget/form-view.html';
        widget.list();
        if(widget.backupRow) {
            widget.currentRow = widget.backupRow;
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Utilities', Utilities);
});